{-# OPTIONS -fglasgow-exts #-}

module Cost (Cost(..), zeroCost, (+$), (-$), Costed(..), (+$$), value) where

import PrelGHC
import PrelBase

data Cost         = Cost#         !Int#

instance Eq Cost where
    Cost# x# == Cost# y# = x# ==# y#
    Cost# x# /= Cost# y# = x# /=# y#

instance Ord Cost where
    Cost# x# <= Cost# y# = x# <=# y#
    Cost# x# <  Cost# y# = x# <#  y#
    Cost# x# >= Cost# y# = x# >=# y#
    Cost# x# >  Cost# y# = x# >#  y#

zeroCost = Cost# 0#

Cost# x# +$ Cost# y# = Cost# (x# +# y#)
Cost# x# -$ Cost# y# = Cost# (x# -# y#)

instance Show Cost where
    showsPrec p (Cost# x#) = showChar '$' . showsPrec p (I# x#)

data Costed a = Costed# {cost :: !Cost , value :: !a}

instance Eq (Costed a) where
  Costed# c1 _ == Costed# c2 _ = c1 == c2

instance Ord (Costed a) where
  Costed# c1 _ <  Costed# c2 _ = c1 <  c2
  Costed# c1 _ <= Costed# c2 _ = c1 <= c2
  Costed# c1 _ >  Costed# c2 _ = c1 >  c2
  Costed# c1 _ >= Costed# c2 _ = c1 >= c2

instance (Show a) => Show (Costed a) where
  showsPrec p (Costed# c a) = showsPrec p c . showChar ':' . showsPrec p a

(+$$) :: Costed [a] -> Costed a -> Costed [a]
Costed# c1 is +$$ Costed# c2 i = Costed# (c1+$c2) (i:is)
