module Util where

-- Really, this is sequencing a state monad
{-# INLINE thread #-}
thread :: (a -> s -> (b, s)) -> [a] -> s -> ([b], s)
thread f [] s = ([], s)
thread f (a:as) s = let (b,s') = f a s
			(bs,s'') = thread f as s'
		    in (b:bs,s'')

-- Probably I'll need to specialize here
genericMin :: (Ord b) => (a -> b) -> [a] -> a
genericMin f (a:as) = genericMin' (a, f a) as
  where
    genericMin' (a, b) [] = a
    genericMin' (a, b) (a1:as) | f a1 < b = genericMin' (a1, f a1) as
			       | otherwise = genericMin' (a, b) as


-- Stricter version of zipWith
zipWith' :: (a -> b -> c) -> [a] -> [b] -> [c]
zipWith' f (a:as) (b:bs) = x `seq` x:zipWith' f as bs where x = f a b
zipWith' _ _ _ = []

