{-# OPTIONS -cpp -fglasgow-exts #-}

module Viterbi(viterbi, viterbis) where

import List
import Cost
import Util

viterbi :: [[Costed a]] -> [a]
viterbi l = reverse (last (viterbis l))

viterbis :: [[Costed a]] -> [[a]]
viterbis dss = map value x
    where {- x :: [Costed [a]] -}
	  x = Costed# zeroCost []:diagMerge [zipWith' (+$$) x ds | ds <- dss]

merge2 :: (Ord a) => [a] -> [a] -> [a]
merge2 l1 l2 = zipWith' min l1 l2

diagMerge :: (Ord a) => [[a]] -> [a]
diagMerge [] = []
diagMerge [xs] = xs
diagMerge ([]:xss) = []
diagMerge ((x:xs):xss) = x:merge2 xs (diagMerge xss)


{-
A reference implementation with a different interface
viterbi1 :: (Num a, Ord a) => (Index -> Index -> a) -> [a]
viterbi1 f = x
  where x = 0:zipWith (+) [f n (n+1) | n <- [0..]] x

viterbi1' :: (Num a) => [a] -> [a]
viterbi1' l = x
  where x = 0:zipWith (+) l x

viterbi2 :: (Num a, Ord a) => (Index -> Index -> a) -> [a]
viterbi2 f = x
  where x = 0:zipWith max (zipWith (+) [f n (n+1) | n <- [0..]] x)
	                  (minBound:zipWith (+) [f n (n+2) | n <- [0..]] x)

max3 a b c = max (max a b) c
viterbi3 :: (Num a, Ord a) => (Index -> Index -> a) -> [a]
viterbi3 f = x
  where x = 0:zipWith3 max3 (zipWith (+) [f n (n+1) | n <- [0..]] x)
	                    (minBound:zipWith (+) [f n (n+2) | n <- [0..]] x)
	                    (minBound:minBound:zipWith (+) [f n (n+3) | n <- [0..]] x)

viterbi :: (Num a, Ord a) => Index -> (Index -> Index -> a) -> [a]
viterbi k f = x where
  x = 0:map maximum (transpose
    (replicate (l-1) minBound ++
       [zipWith (+) [f n (n+l) | n <- [0..]] x | l <- [1..k]]))
-}
